#version 330
#extension GL_EXT_gpu_shader4 : enable
//Golden flow 2Mod01.fsh  by  pik33
//https://www.shadertoy.com/view/wscXRr
// Licence CC0
// Adapted, trivialy, for use in VGHD player
/////////////////////////////////////////////
uniform float u_Elapsed;    // The elapsed time in seconds
uniform vec2  u_WindowSize; // Window dimensions in pixels

#define iTime u_Elapsed*0.314159  //*0.1666
#define iResolution u_WindowSize

//#define mouse AUTO_MOUSE
//#define MOUSE_SPEED vec2(vec2(0.5,0.577777) * 0.25)
//#define MOUSE_POS   vec2((1.0+cos(iTime*MOUSE_SPEED))*u_WindowSize/2.0)
//#define MOUSE_PRESS vec2(0.0,0.0)
//#define AUTO_MOUSE  vec4( MOUSE_POS, MOUSE_PRESS )
//#define RIGID_SCROLL
// alternatively use static mouse definition
#define iMouse vec4(0.0,0.0, 0.0,0.0)
//#define iMouse vec4(512,256,180,120)
uniform sampler2D iChannel0;
uniform sampler2D iChannel1;
uniform sampler2D iChannel2;
uniform sampler2D iChannel3;
vec4 texture2D_Fract(sampler2D sampler,vec2 P) {return texture2D(sampler,fract(P));}
vec4 texture2D_Fract(sampler2D sampler,vec2 P, float Bias) {return texture2D(sampler,fract(P),Bias);}
#define texture2D texture2D_Fract

const float Pi = 3.14159;
void main (void)
//void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    vec2 q=7.0*(gl_FragCoord.xy-0.5*iResolution.xy)/max(iResolution.x,iResolution.y);
    vec2 p=vec2(abs(q.x),q.y);
	
	for(int i=1;i<40;i++)
	{
		vec2 newp=p;
		newp.x+=(0.5/(1.0*float(i)))*cos(float(i)*p.y+iTime*11.0/37.0+0.03*float(i))+1.3;		
		newp.y+=(0.5/(1.0*float(i)))*cos(float(i)*p.x+iTime*17.0/41.0+0.03*float(i+10))+1.9;
		p=newp;
	}

	vec3 col=vec3(0.5*sin(3.0*p.x)+0.5,0.5*sin(3.0*p.y)+0.5,sin(1.3*p.x+1.7*p.y));
    float f=0.43*(col.x+col.y+col.z);

	gl_FragColor=vec4(f+0.6,0.2+0.75*f,0.2,1.0);
}
